"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var custom_exports = {};
__export(custom_exports, {
  createLocalStorage: () => createLocalStorage
});
module.exports = __toCommonJS(custom_exports);
function createLocalStorage({
  namespace
}) {
  const storageKeyPrefix = `${namespace}:`;
  const getStorageKey = (key) => `${storageKeyPrefix}${key}`;
  const storage = {
    setItem: (key, value) => localStorage.setItem(getStorageKey(key), value),
    getItem: (key) => localStorage.getItem(getStorageKey(key)),
    removeItem: (key) => localStorage.removeItem(getStorageKey(key)),
    get length() {
      let keys = 0;
      for (const key in localStorage) {
        if (key.indexOf(storageKeyPrefix) === 0) {
          keys += 1;
        }
      }
      return keys;
    },
    clear() {
      for (const key in localStorage) {
        if (key.indexOf(storageKeyPrefix) === 0) {
          localStorage.removeItem(key);
        }
      }
    }
  };
  return storage;
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  createLocalStorage
});
