import {
  __spreadProps,
  __spreadValues
} from "../chunk-P5H5YIIE.js";
function stringify(obj) {
  return JSON.stringify(obj, null, 2);
}
function formatSingleError(error) {
  return __spreadProps(__spreadValues({}, error), {
    // Raise these details even if they're non-enumerable
    message: error.message,
    stack: error.stack
  });
}
function handleSingleError(error) {
  if (error instanceof Error) {
    return formatSingleError(error);
  }
  return error;
}
function formatError(error) {
  if (Array.isArray(error)) {
    return stringify({
      errors: error.map((e) => handleSingleError(e))
    });
  }
  return stringify({ errors: [handleSingleError(error)] });
}
function formatResult(result) {
  return stringify(result);
}
export {
  formatError,
  formatResult
};
